package guru.kake.ronove

import javafx.stage.Modality
import javafx.stage.StageStyle
import tornadofx.*
import kotlin.system.exitProcess

/**
 * The splash screen show on program startup, allowing the user to create a new project or load an existing
 * one
 * @param project the Project object the data of a new empty project or the chosen loaded project will be
 * stored into
 */
class SplashScreen(project: Project) : View("Ronove") {
    /** TornadoFX root */
    override val root = borderpane {
        center = form {
            fieldset {
            field {
                hyperlink("Dummy 1") {
                    action {
                        project.pages = mutableListOf(
                            Page(listOf(
                                Line("なんでタバコすってんだ？","Why are you smoking?","Why do you smoke?"),
                                Line("んー","Hmm.","Hmm..."),
                                Line("フー","whoosh","Haa...", "SFX: Exhaling"),
                                Line("カツコつけてんの","I'm trying to be cool.",
                                    "I'm just trying to look cool"),
                                Line("かっこいー","That's so cool.", "Coooool!")
                            )),
                            Page(listOf(
                                Line("Sivu 2","Page 2","Page 2"),
                                Line("a","b","c"),Line("a","b","c"),
                                Line("a","b","c")
                            )),
                            Page(listOf(
                                Line("Sivu 3","Page 3","Page 3"),
                                Line("a","b","c"),Line("a","b","c"),Line("a","b","c"),Line("a","b","c"),
                                Line("a","b","c")
                            )),
                            Page(listOf(
                                Line("Sivu 4","Page 4","Page 4"),
                                Line("a","b","c"),Line("a","b","c"),
                                Line("a","b","c")
                            )),
                            Page(listOf(
                                Line("Sivu 5","Page 5","Page 5"),
                                Line("a","b","c"),
                                Line("a","b","c")
                            ))
                        )
                        close()
                    }
                }
                progressbar(0.2)
            }
            field {
                hyperlink("Dummy 2")
                progressbar(0.3)
            }
            field {
                hyperlink("Dummy 3")
                progressbar(0.5)
            }
            field {
                hyperlink("Dummy 4")
                progressbar(0.9)
            }
            field {
                hyperlink("Dummy 5")
                progressbar(0.9)
            }
            field {
                button("New project") {
                    action {
                        ProjectSettings().openModal(
                            stageStyle = StageStyle.UTILITY, block = true,
                            modality = Modality.APPLICATION_MODAL, owner = primaryStage)
                    }
                }
                button("Open...")
                button("Exit") { action { exitProcess(0) }}
            }
            }
        }
        right = imageview("/ronove300.png") {
            fitHeight = 200.0
            isPreserveRatio = true
        }
        visibleProperty().onChange {
            currentWindow?.sizeToScene()
        }
    }

    override fun onDock() {
        modalStage?.width = 450.0
    }
}